generic/520: Remove sync in clean_dir
[xfstests-dev.git] / tests / generic / 168
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
4 #
5 # FS QA Test No. 168
6 #
7 # Test for races or FS corruption when writing to a file that's also
8 # the target of a reflink operation.
9 #
10 seq=`basename $0`
11 seqres=$RESULT_DIR/$seq
12 echo "QA output created by $seq"
13
14 here=`pwd`
15 tmp=/tmp/$$
16 status=1        # failure is the default!
17 trap "_cleanup; exit \$status" 0 1 2 3 7 15
18
19 _cleanup()
20 {
21     cd /
22     rm -rf $tmp.* $finished_file
23     wait
24 }
25
26 # get standard environment, filters and checks
27 . ./common/rc
28 . ./common/filter
29 . ./common/reflink
30
31 # real QA test starts here
32 _supported_os Linux
33 _require_scratch_reflink
34
35 echo "Format and mount"
36 _scratch_mkfs > $seqres.full 2>&1
37 _scratch_mount >> $seqres.full 2>&1
38
39 testdir=$SCRATCH_MNT/test-$seq
40 finished_file=/tmp/finished
41 rm -rf $finished_file
42 mkdir $testdir
43
44 loops=1024
45 nr_loops=$((loops - 1))
46 blksz=65536
47
48 echo "Initialize files"
49 echo >> $seqres.full
50 _pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
51 _pwrite_byte 0x62 0 $((loops * blksz)) $testdir/file2 >> $seqres.full
52 _scratch_cycle_mount
53
54 # Direct I/O overwriter...
55 overwrite() {
56         while [ ! -e $finished_file ]; do
57                 seq $nr_loops -1 0 | while read i; do
58                         _pwrite_byte 0x63 $((i * blksz)) $blksz $testdir/file2 >> $seqres.full
59                 done
60         done
61 }
62
63 echo "Reflink and write the target"
64 overwrite &
65 seq 1 10 | while read j; do
66         seq 0 $nr_loops | while read i; do
67                 _reflink_range  $testdir/file1 $((i * blksz)) \
68                                 $testdir/file2 $((i * blksz)) $blksz >> $seqres.full
69                 [ $? -ne 0 ] && exit
70         done
71 done
72 touch $finished_file
73 wait
74
75 # success, all done
76 status=0
77 exit